<template src="./template.html"></template>

<script lang="ts">
import { getModule } from "nuxt-property-decorator";
import { Vue, Component, Prop, Watch } from "vue-property-decorator";
import CountryFlag from "vue-country-flag";
//@ts-ignore
import listCountry from "~/locales/listCountry.json";
import { ICountry, IShipping, IShippingListPrice } from "interfaces/shipping";
import { find, NumericDictionary } from "lodash";
import { apiErrorHandler } from "~/utils/apiHanlers";

interface IItemQuantity {
  name: string;
  price: number;
  quantity: number;
}

@Component({
  layout: "admin",
  middleware: "authenticated",
  components: {
    CountryFlag,
    EmptyData: () => import("@/components/Utils/EmptyData/index.vue"),
  },
})
export default class AddShippingZoneComponent extends Vue {
  dialogAddItemQuantity = false;
  dialogEditItemQuantity = false;
  dialogAddCountry = false;
  loadingTable = false;
  listCountry = listCountry;
  listCountrySort = [];
  nameSortCountry = "";
  loading = false;
  zoneName = "";
  quantityItems = 0;
  shippingCost = 0;
  shippingName = "";
  country = [];
  shippingQuantity: IShippingListPrice[] = [
    { name: "Standard Rate", price: 0, quantity: 1 },
  ];
  isMax = 0;
  mainQuantity = false;
  listCountryChoose: ICountry[] = [];
  listShipping = [];
  mounted() {
    this.listCountrySort = this.listCountry;
    this.getListShipping();
  }

  async getListShipping() {
    try {
      const response = await this.$api.shipping.allShippingAdmin();
      if (response?.data) {
        this.listShipping = response.data.data;
        const listShippingOther = this.listShipping;
        const listCountryOther: string[] = [];
        listShippingOther.forEach((quocgia: IShipping) => {
          for (let item of quocgia.listCountry) {
            listCountryOther.push(item);
          }
        });
        this.listCountrySort = this.listCountrySort.filter(
          (quocgia: ICountry) => {
            return !listCountryOther.includes(quocgia.code);
          }
        );
      }
    } catch (error) {
      apiErrorHandler(error, this);
    }
  }

  isExistingQuantity = false;

  async postShippingZone() {
    try {
      if (!this.zoneName) {
        return this.$pushNotification.error("Please fill zone name");
      }
      if (!this.listCountryChoose.length) {
        return this.$pushNotification.error("Please choose country");
      }
      if (!this.shippingQuantity) {
        return this.$pushNotification.error("Please choose item quantity");
      }
      const payload = {
        name: this.zoneName,
        listPrice: this.shippingQuantity,
        listCountry:
          this.listCountryChoose.map((country: ICountry) => country.code) || [],
        isRestOfWorld: false,
      };
      this.loading = true;
      await this.$api.shipping.create(payload);
      this.$pushNotification.success("Create shipping successfully");
      this.$router.push("/admin/shipping");
    } catch (error) {
      apiErrorHandler(error, this);
    } finally {
      this.loading = false;
    }
  }

  quantity = {
    name: "",
    price: 0,
    quantity: 0,
  };

  idx: number = 0;

  openDialogEditQuantity(item: IItemQuantity, idx: number) {
    this.dialogEditItemQuantity = true;
    this.quantity = item;
    this.idx = idx;
    this.isExistingQuantity = false;
  }

  deleteItem(idx: number) {
    this.shippingQuantity.splice(idx, 1);
    this.mainQuantity = this.shippingQuantity
      .map((item: any) => {
        return Number(item.quantity);
      })
      .includes(1);
  }

  addItemQuantityRate() {
    if (!this.shippingName) {
      return this.$pushNotification.error("Please fill rate name");
    }
    if (!this.shippingCost) {
      return this.$pushNotification.error("shipping cost must greater than 1");
    }
    if (!this.quantityItems) {
      return this.$pushNotification.error("Please fill quantity");
    }

    this.shippingQuantity.push({
      name: this.shippingName,
      price: this.shippingCost,
      quantity: this.quantityItems,
    });
    this.shippingQuantity.sort((a, b) => {
      return a.quantity - b.quantity;
    });

    this.mainQuantity = this.shippingQuantity
      .map((item: any) => {
        return Number(item.quantity);
      })
      .includes(1);
    this.dialogAddItemQuantity = false;
    this.shippingName = "";
    this.shippingCost = 0;
    this.quantityItems = 0;
    this.isMax = 0;
  }

  editItemQuantityRate() {
    if (!this.quantity.name) {
      return this.$pushNotification.error("Please fill rate name");
    }
    if (!this.quantity.price) {
      return this.$pushNotification.error("Please fill shipping cost");
    }
    if (!this.quantity.quantity) {
      return this.$pushNotification.error("Please fill quantity");
    }
    this.shippingQuantity[this.idx] = this.quantity;
    this.dialogEditItemQuantity = false;
    this.mainQuantity = this.shippingQuantity
      .map((item: any) => {
        return Number(item.quantity);
      })
      .includes(1);
  }

  @Watch("nameSortCountry")
  sortCountryInput(value: string) {
    if (value) {
      this.listCountrySort = this.listCountry.filter((item: any) =>
        item.name.toLowerCase().includes(value.toLowerCase())
      );
    }
  }

  @Watch("quantityItems")
  checkQuantity(value: number) {
    const isExisting = this.shippingQuantity.findIndex(
      (item: IShippingListPrice) => {
        return Number(item.quantity) == Number(value);
      }
    );
    if (isExisting > -1) {
      this.isExistingQuantity = true;
    } else {
      this.isExistingQuantity = false;
    }
    if (this.shippingQuantity && this.shippingQuantity.length) {
      if (
        Number(value) <
        Number(this.shippingQuantity[this.shippingQuantity.length - 1].quantity)
      ) {
        const findMax = this.shippingQuantity.find(
          (item: IShippingListPrice) => {
            return Number(item.quantity) > Number(value);
          }
        );
        if (findMax) {
          this.isMax = Number(findMax.quantity) - 1;
        } else {
          this.isMax = 0;
        }
      } else {
        this.isMax = 0;
      }
    }
  }

  // @Watch("quantity.quantity")
  // checkQuantityEdit(value: number) {
  //   const isExisting = this.shippingQuantity.findIndex(
  //     (item: IShippingListPrice) => {
  //       return item.quantity == value;
  //     }
  //   );
  //   if (isExisting > -1) {
  //     this.isExistingQuantity = true;
  //   } else {
  //     this.isExistingQuantity = false;
  //   }
  //   if (this.shippingQuantity && this.shippingQuantity.length) {
  //     if (
  //       Number(value) <
  //       Number(this.shippingQuantity[this.shippingQuantity.length - 1].quantity)
  //     ) {
  //       const findMax = this.shippingQuantity.find(
  //         (item: IShippingListPrice) => {
  //           return Number(item.quantity) > Number(value);
  //         }
  //       );
  //       if (findMax) {
  //         this.isMax = Number(findMax.quantity) - 1;
  //       } else {
  //         this.isMax = 0;
  //       }
  //     } else {
  //       this.isMax = 0;
  //     }
  //   }
  // }

  onSelectedCountry(quocgia: ICountry) {
    const findIdxCountry = this.listCountryChoose.findIndex(
      (item: ICountry) => {
        return item.code == quocgia.code;
      }
    );
    if (findIdxCountry === -1) {
      this.listCountryChoose.push(quocgia);
    } else {
      this.listCountryChoose.splice(findIdxCountry, 1);
    }
  }

  // @Watch("country")
  // addListCountryChoose(value: string) {
  //   for (let quocgia of value) {

  //   }
  //   console.log(" this.listCountryChoose :>> ", this.listCountryChoose);
  // }
}
</script>
